(function($){
    /**
     *  Sortable clipkit jq-plugin view
     *  @author "Trybynenko Andrii <trybynenko@gmail.com>",
     *  @arguments[0] {Object || Function} options Object or callback function on draging stop
     *
     *  @return {Object} return clipkitSort Object
     */
    $.fn.clipkitSort = function(){
      try {	  
        var appOptions = arguments,
            tobeLoad = [],
            context = this;

        if ($.type(Modernizr) != 'object') // console.log( '_Modernizr required!_' );
            return {views:false};

        if (typeof _ !== 'function')
            tobeLoad.push('//underscorejs.org/underscore.js');
        if (typeof Backbone !== 'object')
            tobeLoad.push('//backbonejs.org/backbone.js');
        if ($.type($.ui) !== 'object') 
            tobeLoad.push('//code.jquery.com/ui/1.10.1/jquery-ui.js');	// tobeLoad.push('/css/jquery-ui-tooltip-dialog.min.css');   
    
        if(tobeLoad.length>0)
            Modernizr.load([{
                'load': tobeLoad,
    //          callback: function(url, result, key) {
    //            console.log('not all resources has been loaded');
    //          },
                'complete': function () {
                    try {
                        // console.log('loaded!');
                        _buildApp(appOptions[0]);
                    } catch (e) {
                        //console.log(e.type,e.message,e.line);
                    }
                }
            }]);
        else
            _buildApp(appOptions[0]);

        function _buildApp(){				
          try {  // console.log('typeof',typeof arguments[0])   console.log(arguments[0])   console.log(_.size(arguments[0]));
		  
            var objOptions = arguments[0]              
                , elSelector = context.size()>0 ? context.selector :  false
				, positionSrc = '#sorted_pl li span:first-child'
                , SortListApp = (function () {
                 
				 if (!elSelector)
					return;
				 
				 if($.type(objOptions) === 'function')
					objOptions = {'onSortStop' : objOptions}; 
				 else if(!$.isPlainObject(objOptions))
					objOptions = {};
								 
				 try {	 // console.log(objOptions,$('body').data('clipkitApp'))
					
					($.type($('body').data('clipkitApp')) === 'undefined') 
					?	$('body').data('clipkitApp', { 'views' : {'sortList':[]} } )
					:	($.type($('body').data('clipkitApp').views) === 'undefined')
						? $('body').data('clipkitApp', { 'views' : {'sortList':[]} } )
						: false;
				 
					var SortList = Backbone.View.extend({
                        positionSrc : ($.type(objOptions.positionSrc) === 'string')? objOptions.positionSrc : false
                      , 'el' : elSelector
                      , 'initialize' : function () {                          
							try {
                                _.bindAll(this,'onSortStop');

                                this.$el.sortable({
                                    placeholder: "ui-state-highlight",
                                    revert:true,
                                    // create:this.sortCreate,
                                    // change:this.sortChange,
                                    // sort:  this.sortStart,
                                    stop:  this.onSortStop
                                }).find("ul, li").disableSelection();
								
								if($.type(objOptions.onInit) === 'function')
									objOptions.onInit();
									
                            } catch (e) {
                            	 console.log(e.type,e.message,e.line);
                            }
                        }
					  ,	'onSortStop': ($.type(objOptions.onSortStop) === 'function') 
							? objOptions.onSortStop
							: function(event, ui) { // console.log(this);
							   if(this.positionSrc)
								   $(this.positionSrc).each(function(i,obj){
										$(obj).text(++i+'.')
								   });
							 }							 
						// sortStart :function(event, ui)  {
                            // console.log(ui,this)
                        // },
                        // sortChange :function(event, ui)  {
                           // console.log(ui,this,event);						  
                        // },
                        // sortCreate: function(event, ui) {
							// console.log(this)
                        // }						
                    }); //SortList

                    $(function () { //TODO: improve for two orme more sort on same page
                         try {
                           $(elSelector).data('clipkitApp',new SortList);
						   $('body').data('clipkitApp').views.sortList.push( $(elSelector).data('clipkitApp') );  // console.log('body',$('body').data('clipkitApp'))   // console.log('sort',$('body').data('clipkitApp').views.sortList)
                         } catch (e) {
                        	 //console.log(e.type,e.message,e.line);
                         }
                    });				
                    return SortList;

                 } catch (e) {
                   //console.log(e.type,e.message,e.line);
                 }
				 
             })(); // SortListApp

          } catch (e) {
              //console.log(e.type,e.message,e.line);
          }
          
        } // buildApp end 
        return context; // console.log('return',clipkitSList);

      } catch (e) {
        //console.log(e.type,e.message,e.line);
      }
    }; //fn.clipkitSort
})(jQuery);